## arcboot 0.3.15

=== arclib/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#
CFLAGS += -O2 -Werror -Wextra -Wall -mno-abicalls -G 0 -fno-pic

TARGETS = libarc.a
OBJECTS = arc.o	stdio.o stdlib.o string.o

all: $(TARGETS)

$(TARGETS): $(OBJECTS)
	rm -f $@
	$(AR) -crs $@ $(OBJECTS)

install: $(TARGETS)
	install -d ${PREFIX}/${LIBDIR}
	install -m 644 $< ${PREFIX}/${LIBDIR}

clean:
	rm -f libarc.a $(OBJECTS) *~ tags

=== common/Makefile ===
SUBARCH ?= IP22

CFLAGS += -Wall -O2 -I. -I../arclib -DSUBARCH=${SUBARCH}

HOSTCC = $(CC)
HOSTCFLAGS += -Wall -O2 -DSUBARCH=$(SUBARCH)

all:

clean:
	rm -f  *~ tags

=== ext2load/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#           2001-04 Guido Guenther <agx@sigxcpu.org>
#

SUBARCH ?= IP22

COMMONDIR = ../common

E2FSINCLUDEDIR ?= /usr/include/ext2fs
E2FSLIBDIR ?= /usr/lib
EXT2LIB ?= $(E2FSLIBDIR)/libext2fs-nopic.a

ARCINCLUDEDIR = ../arclib
ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

OBJECTS = loader.o ext2io.o conffile.o
LIBS = $(EXT2LIB) $(ARCLIB)
TARGETS = ext2load 

MIPS_CFLAGS = -mno-abicalls -G 0 -fno-pic
WARN_CFLAGS = -Wextra -Wall
# uncomment for debugging
#DEBUG_CFLAGS = -DDEBUG

CFLAGS = -O2 -I$(COMMONDIR) -I$(ARCINCLUDEDIR) -I$(E2FSINCLUDEDIR) \
	 -DSUBARCH=${SUBARCH} -fno-strict-aliasing \
	 $(WARN_CFLAGS) $(MIPS_CFLAGS) $(DEBUG_CFLAGS)

LD = ld
LDFLAGS = -N -T ld.script

all:  $(TARGETS)

ext2load:  $(OBJECTS) $(LIBS) ld.script ../common/subarch.h
	rm -f $@
	$(LD) $(LDFLAGS) -o $@ $(OBJECTS) $(LIBS)

ld.script: ld.script.in
	$(MAKE) -C ../common SUBARCH=$(SUBARCH)
	LOADADDR=$(LOADADDR);	 				\
	OUTPUTFORMAT=$(OUTPUTFORMAT);				\
	sed -e "s/@@LOADADDR@@/$$LOADADDR/"			\
	-e "s/@@OUTPUTFORMAT@@/$$OUTPUTFORMAT/" <$< >$@

install:

clean:
	rm -f $(TARGETS) *.a *.o tags ld.script

=== tip22/Makefile ===
#
# Copyright 2002-2004,2011 Guido Guenther <agx@sigxcpu.org>
#

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

COMMONDIR = ../common

MIPS_CFLAGS = -mno-abicalls -G 0 -fno-pic
WARN_CFLAGS = -Wextra -Wall
# uncomment for debugging
#DEBUG_CFLAGS = -DDEBUG
CFLAGS += -O2 -I$(COMMONDIR) -I$(ARCLIBDIR) \
	  -DSUBARCH=${SUBARCH} -fno-strict-aliasing \
	  $(WARN_CFLAGS) $(MIPS_CFLAGS) $(DEBUG_CFLAGS)

ASFLAGS = -O2 -mno-abicalls -G 0 -fno-pic

LIBDIR ?= /usr/lib/tip22
BINDIR ?= /usr/sbin

LIBS=${ARCLIB}
BINS=tip22 tip32
LD_SCRIPTS = ld.kernel.script.$(SUBARCH) ld.ramdisk.script.$(SUBARCH) ld.script.$(SUBARCH)
OBJECTS = tftpload.$(SUBARCH).o
TARGETS = $(OBJECTS) $(LD_SCRIPTS)

# uncomment for debugging
#CFLAGS+=-DDEBUG

all: ${LIBS} ${BINS} $(TARGETS)

$(ARCLIB):
	@$(MAKE) -C $(ARCLIBDIR)

%.$(SUBARCH).o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

%.script.$(SUBARCH): %.script.in
	LOADADDR=$(TIP_LOADADDR);				\
	OUTPUTFORMAT=$(OUTPUTFORMAT);				\
	sed -e "s/@@LOADADDR@@/$$LOADADDR/"			\
	-e "s/@@OUTPUTFORMAT@@/$$OUTPUTFORMAT/" <$< >$@

clean:
	rm -f tags *~
	rm -f $(TARGETS)

install: all
	install -d ${PREFIX}/${BINDIR}
	install -m 755 ${BINS} ${PREFIX}/${BINDIR}
	$(foreach tg,$(TARGETS),install -m 644 $(tg) ${PREFIX}/${LIBDIR};)


.PHONY: all archall clean archclean install archinstall

=== debian/changelog ===
arcboot (0.3.15) unstable; urgency=low

  * [7154bce] Cleanup all subarches
  * [804c3aa] Use -Wextra
  * [f628a0e] Mark unused parameters as __attribute__((unused)) or remove them
    if not part of the ext2lib ABI
  * [77a5233] Switch to source format 3.0 (native)
  * [dbf6fd9] Bump standards version (no changes)
  * [662b81a] Update debian/copyright
  * [8e0eadf] postinst: Drop path from arcboot invocation
  * [83171b6] overrides: remove ./ from paths to catch up with ftp-master
    changes
  * [bb6bd2f] Reduced amount of #ifdef'ed code
  * [5184fe4] Split CFLAGS to ease compilation on other platforms
  * [aaab7cb] Ease building on non MIPS platforms
  * [0b76795] Disable strict-aliasing as in arcboot
  * [61418bf] Drop .gnu.att section mapped add VMA 0

 -- Guido Günther <agx@sigxcpu.org>  Sun, 19 Jun 2011 17:08:14 +0200

arcboot (0.3.14) unstable; urgency=low

  * [01c99b5] Move the tip22 image to 0x89702000 on IP22 as described in
    #452798. Thanks to Edwin Kwan for analyzing this.
  * [399eff1] Fix address substitution for IP32 it was being handled as IP22
    in tip22.

 -- Guido Günther <agx@sigxcpu.org>  Thu, 16 Jun 2011 23:38:40 +0200

=== debian/control ===
Source: arcboot
Section: admin
Priority: optional
Maintainer: Guido Günther <agx@sigxcpu.org>
Build-Depends: debhelper (>=4.1.16), e2fslibs-dev
Vcs-Git: git://honk.sigxcpu.org/git/arcboot.git/
Homepage: https://honk.sigxcpu.org/piki/projects/arcboot/
Standards-Version: 3.9.2

Package: arcboot
Architecture: mips
Depends: dvhtool, ${misc:Depends}
Description: Bootloader for MIPS based SGI IP22 and IP32 machines
 arcboot is a bootloader for SGI IP22 and IP32 machines like the Indy, Indigo2
 and O2. It is able to boot the Linux kernel from ext2 and ext3 filesystems.
 Support for other ARCS based subarchitectures can easily be added. It is
 currently not capable of booting IRIX or to boot from iso9660 CDROMs though.

Package: tip22
Architecture: mips
Depends: ${misc:Depends}, binutils, file
Description: Tftp boot image builder for MIPS based SGI IP22 and IP32 machines
 tip22 is used to merge kernel and initrd into one bootable image. This
 image also contains a small loader stub that copies the kernel to its
 load address and appends the ramdisk. This is useful for booting via tftp or
 from a CDROM. It is currently targeted for the IP22 and IP32 subarchitectures
 but support for other ARCS based subarchitectures can easily be added.
